'    ______________________________
'   ( ABC Australia: News Just In  )
'    
'                    __________________
'                   ( V2.0 by clarence )
'                    

'   This script grabs the headlines and the bylines from the Just In section of
'   the ABC Australia News website at abc.net.au/news/justin/

'   It has two functions you will find in the Serious Samurize config editor.
'   They are -
'		| GetData
'		| This function *MUST* be displayed in your config for the script
'		| to download the latest news every 60 minutes.
'		| GetData will display a countdown from 60 to 0 so you know 
'		| how long it will be till the next update.

'		| Headline
'		| This function displays the headlines. Set the "Run every X min"
'		| option in the Serious Samurize config editor to 1 to have a new
'		| headline displayed every minute. Place a rectangle with a setting
'		| of 1 AlphaBlending behind Headline to get the clickable links 
'		| working. 

'   Enjoy.



':   :  : :: Set the variables here or just leave as is for maximum flavour :: :  :   :


' The Headline is defined as the heading of the news item.

' The Byline is defined as the short descriptive text associated with a particular Headline.

'-------------------------------------------------------------------------------
'* How long should the byline rows be until they go to another line?		|
'	( i.e. increase/decrease this number for longer/shorter lines )		|															|
             cutlength = 75
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'* Display the bylines? True or False						|
'										|
         DisplayBLines = True
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'*Display the headline time? True or False					|
'										|
          HeadlineTime = False ' False disables Time display
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'* Would you like headline numbers displayed? True or False			|
'										|
        HeadLineNumber = True 'False disables head line numbers.
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'* If HeadLineNumber is True then what kinda fancy little thing			|
'  would you like around the number?						|
'										|
 HeadLineNumberLeftTag = "["
HeadLineNumberRightTag = "]"
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'* What fancy thing do you want around the Headlines?				|
'										|
       HeadlineLeftTag = ""
      HeadlineRightTag = ""
'-------------------------------------------------------------------------------
'* Time and Headline Seperator What kinda fancy thing do you want to		|
'  seperate the time and headline ?						|
'										|
   Time_Head_Seperator = ": "
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'* "Update pre message" is displyed before the countdown number.	   	|
'  "Update post message" is displyed after the countdown number.	   	|
'  ( i.e. the default settings will look like this-> ABC News Upd :: 23 :: )  	|
'									   	|
    Update_Pre_Message = ":"
   Update_Post_Message = ""
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'* The update message tp display when a successful download occurs.		|
'										|
         UpdateMsg = "Ok"
'-------------------------------------------------------------------------------

'       * Your probably better off leaving these tempfiles set as is.

              TempFile = "C:\Program Files\Samurize\Scripts\abcjustintst.txt"

          TempFile2 = "C:\Program Files\Samurize\Scripts\abcjicnttst.txt"



'   :   :  : :: Do not modify after this point :: :  :   :


Function Headline()
Set fileobj = CreateObject("Scripting.FileSystemObject")
Set filepath = fileobj.GetFile(TempFile)
Set thetmpfile = filepath.OpenAsTextStream(1, -2)
intext = thetmpfile.ReadAll
thetmpfile.Close
Set fileobj = Nothing
Set filepath = Nothing
Set fileobj2 = CreateObject("Scripting.FileSystemObject")
If (fileobj2.fileexists(TempFile2)) = True Then
Set filepath2 = fileobj2.GetFile(TempFile2)
Set thecntfile = filepath2.OpenAsTextStream(1, -2)
whatsnext = thecntfile.ReadLine
thecntfile.Close
Set fileobj2 = Nothing
Set filepath2 = Nothing
Else
Set fs = CreateObject("Scripting.FileSystemObject")
Set f = fs.CreateTextFile(TempFile2, True)
f.WriteLine ("1")
f.Close
Set fs = Nothing
Set f = Nothing
whatsnext = 1
End If
outhead = Extract(intext, "Start H" & whatsnext & "*", "End H" & whatsnext & "*")
If outhead = "this is the end" Then
whatsnext = 1
outhead = Extract(intext, "Start H" & whatsnext & "*", "End H" & whatsnext & "*")
outime = Extract(intext, "Start T" & whatsnext & "*", "End T" & whatsnext & "*")
outbline = Extract(intext, "Start B" & whatsnext & "*", "End B" & whatsnext & "*")
outlink = Extract(intext, "Start L" & whatsnext & "*", "End L" & whatsnext & "*")
whatsnext = 0
Else
outime = Extract(intext, "Start T" & whatsnext & "*", "End T" & whatsnext & "*")
outbline = Extract(intext, "Start B" & whatsnext & "*", "End B" & whatsnext & "*")
outlink = Extract(intext, "Start L" & whatsnext & "*", "End L" & whatsnext & "*")
End If
whatsnext = whatsnext + 1
outhead = HeadlineLeftTag & outhead & HeadlineRightTag
Set fileobj2 = CreateObject("Scripting.FileSystemObject")
Set thecntfile = fileobj2.CreateTextFile(TempFile2, True)
thecntfile.WriteLine (whatsnext)
thecntfile.Close
Set fileobj2 = Nothing
Set thecntfile = Nothing
startbit = ""
If HeadLineNumber = True Then
startbit = HeadLineNumberLeftTag & whatsnext & HeadLineNumberRightTag
End If
If HeadlineTime = True Then
startbit = startbit & Time_Head_Seperator & outime
End If
If DisplayBLines = False Then
Headline = outhead & outlink
Exit Function
End If
'ShByLine(outbline)
Headline = startbit & " " & outhead & "%b" & outlink
End Function

Private Function ShByLine(bstuff)
ShByLine=SplitIt(bstuff)
End Function

Function ByLine()
Set fileobj = CreateObject("Scripting.FileSystemObject")
Set filepath = fileobj.GetFile(TempFile)
Set thetmpfile = filepath.OpenAsTextStream(1, -2)
intext = thetmpfile.ReadAll
thetmpfile.Close
Set fileobj = Nothing
Set filepath = Nothing
Set fileobj2 = CreateObject("Scripting.FileSystemObject")
Set filepath2 = fileobj2.GetFile(TempFile2)
Set thecntfile = filepath2.OpenAsTextStream(1, -2)
whatsnext = thecntfile.ReadLine
thecntfile.Close
Set fileobj2 = Nothing
Set filepath2 = Nothing
outext = Extract(intext, "Start B" & whatsnext & "*", "End B" & whatsnext & "*")
If outext = "this is the end" Then
whatsnext = 1
outext = Extract(intext, "Start B" & whatsnext & "*", "End B" & whatsnext & "*")
whatsnext = 0
End If
ByLine = WrapText(outext)
'ByLine = SplitIt(outext)
End Function




Private Function TimeDiff(file)
    Dim fs, f, diff
    Set fs = CreateObject("Scripting.FileSystemObject")
    If fs.fileexists(file) Then
        Set f = fs.GetFile(file)
        diff = DateDiff("n", f.DateLastModified, Now())
    Else
        diff = 0
    End If
    Set f = Nothing
    Set fs = Nothing
    TimeDiff = diff
End Function

Function UpdateCacheFile()
cntr = 1
tt = TimeDiff(TempFile)
GetURL = "http://www.abc.net.au/news/justin/default.htm?1"
Set tst_obj = CreateObject("Scripting.FileSystemObject")
If (Not tst_obj.fileexists(TempFile)) Then
tt = 61
End If

If tt > 60 Then

       Dim HTTP
        Set HTTP = CreateObject("Microsoft.XMLHTTP")
        HTTP.Open "GET", GetURL, False
        HTTP.Send
        HTMLResult = BinToText(HTTP.ResponseBody, 35000)
	Set HTTP = Nothing
	'HTMLResult = TrimHTML(HTMLResult)
        HTMLResult = TrimALL(HTMLResult)
        Result = Extract(HTMLResult,"START HEADLINE","END HEADLINE")
        Set fs = CreateObject("Scripting.FileSystemObject")
            Set f = fs.CreateTextFile(TempFile, True)
	  'f.WriteLine Result
	  'Exit Function
        HeadlinePtn = "<p class=posted>(.*?)STORY</a>"
        HeadMatchNum = 0
        
            Set HeadlineGrab = New RegExp
            HeadlineGrab.Global = True
            HeadlineGrab.IgnoreCase = True
            HeadlineGrab.Pattern = HeadlinePtn
            Set Matches = HeadlineGrab.Execute(Result)
            For Each Match In Matches
                News = Trim(Match.SubMatches(HeadMatchNum))
            'f.WriteLine News
            'Next
            'Exit Function
            HTime = Extract(News, "Posted: ", "</p> <h1 class=indexheadline>")
            HLine = Extract(News, ".htm>", "</a>")
            Bline = Extract(News, "firstwallacepara>", "</p> <p class=fullstorylink>")
            HLink = "%lwww.abc.net.au/news/newsitems/s" & Extract(News, "><a name=", " /><A") & ".htm"
        f.WriteLine ("Start T" & cntr & "*" & HTime & "End T" & cntr & "*")
        f.WriteLine ("Start H" & cntr & "*" & HLine & "End H" & cntr & "*")
        f.WriteLine ("Start B" & cntr & "*" & Bline & "End B" & cntr & "*")
        f.WriteLine ("Start L" & cntr & "*" & HLink & "End L" & cntr & "*")
            cntr = cntr + 1
            Next
        f.WriteLine ("Start H" & cntr & "*" &  "this is the end" & "End H" & cntr & "*")
            f.Close
            Set fs = Nothing
            Set f = Nothing
UpdateCacheFile = UpdateMsg
Else
tt = 60 - tt
UpdateCacheFile = Update_Pre_Message & tt & Update_Post_Message
End If
End Function

'=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-

Private Function TrimALL(texttotrim)
TrimALL = texttotrim

While InStr(TrimALL, vbCrLf) > 0
    TrimALL = Replace(TrimALL, vbCrLf, " ")
Wend

Do While InStr(TrimALL, vbTab) > 0
    TrimALL = Replace(TrimALL, vbTab, " ")
Loop

For x = 0 To 31
    Do While InStr(TrimALL, Chr(x)) > 0
        TrimALL = Replace(TrimALL, Chr(x), "")
    Loop
Next

For x = 127 To 255
    Do While InStr(TrimALL, Chr(x)) > 0
        TrimALL = Replace(TrimALL, Chr(x), "")
    Loop
Next

Do While InStr(TrimALL, String(2, " ")) > 0
    TrimALL = Replace(TrimALL, String(2, " "), " ")
Loop

TrimALL = Replace(TrimALL, "&nbsp;", "")
TrimALL = Replace(TrimALL, Chr(34), "")
    
End Function

Private Function BinToText(varBinData, intDataSizeInBytes)    ' as String
  Const adFldLong = &H80
  Const adVarChar = 200
  Set objRS = CreateObject("ADODB.Recordset")
  objRS.Fields.Append "txt", adVarChar, intDataSizeInBytes, adFldLong
  objRS.Open
  objRS.AddNew
  objRS.Fields("txt").AppendChunk varBinData
  BinToText = objRS("txt").Value
  objRS.Close
  Set objRS = Nothing
End Function



Private Function TrimHTML(str)
pos_deb = InStr(1, str, "<" )
Do Until pos_deb = 0
pos_fin = InStr(pos_deb, str, ">" )
part_d = Mid(str, 1, pos_deb - 1)
part_f = Mid(str, pos_fin + 1, Len(str) - pos_fin)
str = part_d & part_f
pos_deb = InStr(1, str, "<" )
Loop
TrimHTML = str
End Function


Private Function Extract(stn,first,last)
st = InStr(1, stn, first) + Len(first)
nd = InStr(st, stn, last)
extract = Mid(stn,st,nd-st)
End Function

Private Function WrapText(stng)
strtcut = 0
endcut = InStr(1, stng, " ", 1)
Do
   If InStr(endcut + 1, stng, " ", 1) > cutlength + strtcut Then
   result = result & Mid(stng, strtcut + 1, endcut - strtcut) & "%b"
   strtcut = endcut
   Else
   endcut = InStr(endcut + 1, stng, " ", 1)
   End If
Loop While Not endcut = 0
WrapText = result & Mid(stng, strtcut + 1, Len(stng) - strtcut)
End Function


